/*	PLUGIN REDIRECT
	WRITTEN BY: [WING] Sir Drink a lot
	visit www.adminmod.de
	
	DESCRIPTION: 	If you write "redirect me" in chat, a serverlist-menu
			will open, where you can select the server.
			You can use a redirectconsgreet.cfg for consgreet-messages.
			You must use a redirectserver.cfg for more redirect servers.(hostnameIP:Port)
			All redirections are logged in 'redirectlog.cfg'			
			If server is full and player has not the rightlevel 32768, he will be
			redirected to a random server.
			admin_redirect 'player' will also connect this player to another random server
			in the list.(999 = random server)
			
	COMMANDS:	
			admin_redirect 'player' [server_id]:	redirects player to another server.
			
	VAULT.INI:	
			REDIRECT_CONSGREET 0/1		:consgreet on/off
			REDIRECT_REPEATMSG 0/1		:repeat message on/off
			REDIRECT_FULLSERVER 0/1		:if server is full, redirect randomly to another server
			
	---Changelog---
	
	19.01.03:	first release
*/

#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>

new STRING_VERSION[MAX_DATA_LENGTH] = "19.01.03";

new RedirectServerCFG[MAX_TEXT_LENGTH]="addons/adminmod/config/redirectserver.cfg";
new RedirectConsgreetCFG[MAX_TEXT_LENGTH]="addons/adminmod/config/redirectconsgreet.cfg";
new RedirectLogCFG[MAX_TEXT_LENGTH]="addons/adminmod/config/redirectlog.cfg";

new MenuID[MAX_PLAYERS];
new SelectedServerLoop[MAX_PLAYERS]={1,1,...};
new SelectedServer[MAX_PLAYERS];

/*Loading server list*/
#define MAX_IPS	20
new servercount=0;
new ServerIP[MAX_IPS][MAX_TEXT_LENGTH];
new Servername[MAX_IPS][MAX_TEXT_LENGTH];

/*Settings*/
new Hostname[MAX_DATA_LENGTH];
new cg;
new rm;
new far;
new faw;
new fs;

public plugin_init() {
	plugin_registerinfo("PLUGIN SDAL REDIRECT","Redirect to another server",STRING_VERSION);
	
	plugin_registercmd("admin_redirect","admin_redirect",ACCESS_BAN,"admin_redirect 'player' [server_id]: Spieler auf anderen Server umleiten");
	/*plugin_registercmd("admin_redirect_ip","admin_redirect_ip",ACCESS_RCON,"admin_redirect_ip 'servername' 'ip:port': erweitert die Serverliste");*/
	plugin_registercmd("radio1","SetMenuData",ACCESS_ALL);
	plugin_registercmd("radio2","SetMenuData",ACCESS_ALL);
	plugin_registercmd("radio3","SetMenuData",ACCESS_ALL);
	plugin_registercmd("buyequip","SetMenuData",ACCESS_ALL);
	plugin_registercmd("buy","SetMenuData",ACCESS_ALL);
	plugin_registercmd("chooseteam","SetMenuData",ACCESS_ALL);
	plugin_registercmd("menuselect","menuselect",ACCESS_ALL);
	plugin_registercmd("showbriefing","SetMenuData",ACCESS_ALL);
	plugin_registercmd("say","HSay",ACCESS_ALL);
	plugin_registercmd("say_team","HSay",ACCESS_ALL);
	plugin_registerhelp("say",ACCESS_ALL,"say 'redirect me': oeffnet ein Menue mit Serverliste, wohin man connecten moechte.");
	
	/*server and vault.ini infos*/
	getstrvar( "hostname", Hostname, MAX_DATA_LENGTH );
	far=getvar("file_access_read");
	faw=getvar("file_access_write");
	get_vaultnumdata("REDIRECT_CONSGREET",cg);
	get_vaultnumdata("REDIRECT_REPEATMSG",rm);
	get_vaultnumdata("REDIRECT_FULLSERVER",fs);
	
	if(far==0){
		selfmessage("[SDAL-REDIRECT] file_access_read 0 -> plugin error!! Read manuell!");
	}
	if(faw==0){
		selfmessage("[SDAL-REDIRECT] file_access_write 0 -> plugin error!! Read manuell!");
	}
	if(rm==1){
		set_timer("display_all",315,99999);
	}else{
		selfmessage("[SDAL-REDIRECT] Repeat message disabled!");
	}
	if(cg==0){
		selfmessage("[SDAL-REDIRECT] Consgreet message disabled!");
	}
	load_serverlist();
	
	return PLUGIN_CONTINUE;
}

public admin_redirect(HLCommand, HLData, HLUserName, UserIndex){
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new Target[MAX_NAME_LENGTH];
	new ServerID[3];
	new iServerID;
	
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	strbreak(Data,Data,ServerID,MAX_DATA_LENGTH);
	if(strlen(Data)!=0){
		if (check_user(Data) != 0) {
			get_username(Data,Target,MAX_NAME_LENGTH);
			if(check_immunity(Target)!=0) {
				snprintf(Text, MAX_TEXT_LENGTH, "LOL. Du kannst %s nicht umleiten. Er hat Immunitaet!", Target);
				selfmessage(Text);
			}else{
				iServerID=strtonum(ServerID);
				if(iServerID==0 || iServerID > servercount){
					redirect(Target,999);
				}else{
					redirect(Target,iServerID);
				}
			}
		}else{
			snprintf(Text, MAX_TEXT_LENGTH, "Sorry, Spieler %s nicht eindeutig identifiziert!", Data);
			selfmessage(Text);
		}
	}else{
		snprintf(Text, MAX_TEXT_LENGTH, "admin_redirect 'playername': Du musst einen Spielernamen eingeben");
		selfmessage(Text);
	}
	return PLUGIN_HANDLED;
}

/*
public admin_redirect_ip(HLCommand, HLData, HLUserName, UserIndex){
	
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new IP[MAX_TEXT_LENGTH];
	new ServName[MAX_TEXT_LENGTH];
	new i;
	
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	
	if(strlen(Data)!=0){
		strbreak(Data,ServName,IP,MAX_TEXT_LENGTH);
		i=strcount(IP, '.');
		if(i==3){
			snprintf(Text,MAX_DATA_LENGTH,"%s: Neuen Redirect Server hinzugefgt:%s",User,Data);
			selfmessage(Text);
			writefile(RedirectServerCFG,Data,-1);
			log(Text);
			load_serverlist();
		}else{
			snprintf(Text,MAX_DATA_LENGTH,"Die IP ist nicht korrekt:%s",Data);
			selfmessage(Text);
		}
	}else{
		snprintf(Text, MAX_TEXT_LENGTH, "admin_redirect_ip 'servername' 'IP:Port': Du musst den Servernamen und IP mit Port angeben");
		selfmessage(Text);
	}
	return PLUGIN_HANDLED;
}
*/
/*Consgreet*/
public plugin_connect(HLUserName,HLIP, UserIndex) {
	new Text[MAX_TEXT_LENGTH];
	new User[MAX_NAME_LENGTH];
	new iLine;
	new i;
	
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	if(fs==1){
		if (getvar("public_slots_free 0") == 1) {
			if(!check_auth(32768)) {
				snprintf(Text, MAX_TEXT_LENGTH, "> Sorry %s, aber <%s> ist voll...^nDu wirst zu %s umgeleited.", User, Hostname, ServerIP);
				consgreet(Text);
				snprintf(Text, MAX_TEXT_LENGTH, "> Sorry %s, but <%s> is full...^nYou are being ReDirected to %s.", User, Hostname, ServerIP);
				consgreet(Text);
				redirect(User,999);
			}
		}
	}
	if(cg==1){
		consgreet("");
		consgreet("********* PLUGIN SDAL-REDIRECT ************");
		consgreet("> Weiterleitung zu einem anderen Server:");
		consgreet(">");
		if(fileexists(RedirectConsgreetCFG)){
			iLine=filesize(RedirectConsgreetCFG);
			for(i=1;i<=iLine;i++){
				readfile(RedirectConsgreetCFG,Text,i,MAX_DATA_LENGTH);
				strcpy(Text,Text,98);
				consgreet(Text);
			}
		}else{
			snprintf(Text,MAX_TEXT_LENGTH,"> Wir haben auch andere Server!");
			consgreet(Text);
			snprintf(Text,MAX_TEXT_LENGTH,"> Schreibe 'redirect me' im Chat und ");
			consgreet(Text);
			snprintf(Text,MAX_TEXT_LENGTH,"> ueber ein Menue kannst Du den/die Server");
			consgreet(Text);
			snprintf(Text,MAX_TEXT_LENGTH,"> angeben, wohin Du wechseln moechtest!");
			consgreet(Text);
			consgreet(">");
			snprintf(Text,MAX_TEXT_LENGTH,"> We have also other server!");
			consgreet(Text);
			snprintf(Text,MAX_TEXT_LENGTH,"> Write 'redirect me' in chat to open a");
			consgreet(Text);
			snprintf(Text,MAX_TEXT_LENGTH,"> menu where you can select another server");
			consgreet(Text);
			snprintf(Text,MAX_TEXT_LENGTH,"> to join!");
			consgreet(Text);
		}
	}
	consgreet(">");
	consgreet("**********************************************************");
	reset_array(UserIndex);
	return PLUGIN_CONTINUE;
}

public HSay(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	
	
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_DATA_LENGTH);
	strstripquotes(Data);
	
	if(strcmp(Data,"redirect me")==0){
		redirectmenu(User,UserIndex);
		return PLUGIN_HANDLED;
	}
	
	return PLUGIN_CONTINUE;
}

/*Menue*/
redirectmenu(User[],UserIndex){
	new Text[512];
	new Command[MAX_TEXT_LENGTH];
	new i;
	new l=0;
	new a=1;
	new keys=0;
	snprintf(Text,MAX_TEXT_LENGTH,"\yRedirect Server-List:^n");
	for(i=SelectedServerLoop[UserIndex];i<=servercount;i++){
		l++;
		snprintf(Command,MAX_TEXT_LENGTH,"\w^n%i. %s",l,Servername[i]);
		strcat(Text,Command,MAX_TEXT_LENGTH);
		a+=a;
		keys=a-1;
		if(l==5){
			if(servercount>=SelectedServerLoop[UserIndex]+5){
				strcat(Text,"\y^n^n8. Next",MAX_TEXT_LENGTH);
				keys+=128;
			}
			break;
		}
	}
	if(SelectedServerLoop[UserIndex]>=5){
		strcat(Text,"\y^n^n9. Back",MAX_TEXT_LENGTH);
		keys+=256;
	}
	strcat(Text,"\r^n^n0. Cancel",MAX_TEXT_LENGTH);
	keys+=512;
	menu(User,Text,keys);
	MenuID[UserIndex]=1;
	return 0;
}

/*Auswertung der Menauswahl*/
public menuselect(HLCommand,HLData,HLUserName,UserIndex){
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
  	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	
	if(MenuID[UserIndex]==1){
		SelectedServer[UserIndex]=strtonum(Data);
		if(SelectedServer[UserIndex]==8){
			SelectedServerLoop[UserIndex]=SelectedServerLoop[UserIndex]+5;
			redirectmenu(User,UserIndex);
			return PLUGIN_HANDLED;
		}else if(SelectedServer[UserIndex]==9){
			SelectedServerLoop[UserIndex]=SelectedServerLoop[UserIndex]-5;
			redirectmenu(User,UserIndex);
			return PLUGIN_HANDLED;
		}else if(SelectedServer[UserIndex]==10){
			reset_array(UserIndex);
			return PLUGIN_HANDLED;
		}else{
			if(SelectedServerLoop[UserIndex]>=5){
				SelectedServer[UserIndex]=SelectedServerLoop[UserIndex]+SelectedServer[UserIndex]-1;
			}else{
				SelectedServer[UserIndex]=SelectedServer[UserIndex];
			}
			redirect(User,SelectedServer[UserIndex]);
			return PLUGIN_HANDLED;
		}
	}
	return PLUGIN_CONTINUE;
}

public display_all(Timer,Repeat,HLName,HLParam) {
	new Text[MAX_TEXT_LENGTH];
	snprintf(Text,MAX_TEXT_LENGTH," Wir haben auch andere Server!^n Schreibe im Chat 'redirect me '^n und ein Menue erscheint!",ServerIP);
	centersay(Text,12,255,255,255);
	say(Text);
	return PLUGIN_CONTINUE;
}

public plugin_disconnect(HLUserName,UserIndex){
	if(MenuID[UserIndex]==1){
	     	reset_array(UserIndex);   	
	}
	return PLUGIN_CONTINUE;
}

public SetMenuData(HLCommand,HLData,HLUserName,UserIndex){
	if(MenuID[UserIndex]==1){
		reset_array(UserIndex);
	}
	return PLUGIN_CONTINUE;
}

reset_array(UserIndex){
	MenuID[UserIndex]=0;
	SelectedServer[UserIndex]=0;
	SelectedServerLoop[UserIndex]=1;
	return PLUGIN_CONTINUE;
}

redirect(User[],server){
	new Command[MAX_DATA_LENGTH]="connect ";
	new Text[MAX_TEXT_LENGTH];
	new Date[MAX_TEXT_LENGTH];
	servertime(Date, MAX_NUMBER_LENGTH, "%m/%d/%y %H:%M:%S");
	if(server==999){
		server=random(servercount);
	}
	strcat(Command,ServerIP[server],MAX_TEXT_LENGTH);
	snprintf(Text,MAX_TEXT_LENGTH,"Du wirst zu %s umgeleitet!",ServerIP[server]);
	messageex(User,Text,print_chat);
	messageex(User,Text,print_console);
	execclient(User,Command);
	snprintf(Text, MAX_TEXT_LENGTH, "%s: redirected <%s> to <%s>", Date, User, Servername[server]);
	writefile(RedirectLogCFG, Text,-1);
	return PLUGIN_HANDLED;
}

/*Ldt die Serverliste*/
load_serverlist(){
	new Data[MAX_DATA_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new j;
	new iLineCount;
	
	iLineCount=filesize(RedirectServerCFG);
	if(iLineCount>=MAX_IPS){
		snprintf(Text,MAX_TEXT_LENGTH,"[SDAL-REDIRECT] Too many lines in redirectserver.cfg. Increase MAX_IPS in Source-Code");
		selfmessage(Text);
		iLineCount=MAX_IPS;
	}
	for(j=1; j <= iLineCount; j++){
		readfile(RedirectServerCFG,Data,j,MAX_TEXT_LENGTH);
		if(strncmp(Data,"//",2)!=0 && strlen(Data)!=0 && strncmp(Data,";",1)!=0){
			servercount++;
			strsplit(Data,"",Servername[servercount],MAX_TEXT_LENGTH,ServerIP[servercount],MAX_TEXT_LENGTH);
			
		}
	}
	snprintf(Text,MAX_TEXT_LENGTH,"[SDAL-REDIRECT] %i servers loaded successfully",servercount);
	selfmessage(Text);
	return PLUGIN_CONTINUE;
}